#include <iostream>

using namespace std;
long long a[500001],b[500001];
int main()
{
    long long n,k;
    long long i,j,c,d;
    cin>>n;
    cin>>k;
    d=k;
    for(i=0;i<n;i++)
    {
        cin>>a[i];
    }
    i=0;
    c=0;
    while(k>0)
    {
        j=1;
        while(j<=k)
        {
            if(a[i]>a[j+i])
            {
                i=i+j;
                k=k-j;
            }
            else
                j++;
        }
        if(j==k+1)
        {
           b[c]= a[i];
           c++;
           i++;
        }

    }
    while(c<=n-k)
    {
        b[c]=a[i];
        c++;
        i++;
    }
    for(i=0;i<n-d;i++)
    {
        cout<<b[i]<<" ";
    }
    return 0;
}